//+------------------------------------------------------------------+
//|                                                  Shartingale.mq4 |
//|                                                             Shiv |
//|                                      Coded By Santhosh44, Elance |
//+------------------------------------------------------------------+
#property copyright "Shiv"
#property link      ""
#define   NL        "\n"

extern string  s1 = "=== Basic Settings ===";
extern double  MaxSpread      = 5;
extern int     Magic          = 6666;
extern int     GridSpace      = 100;
extern double  StartLot       = 0.1;
extern double  Multiplier     = 2.1;
extern int     TradesPerLevel = 3;
extern int     SL             = 1000;
extern int     TP             = 1000;

extern string  s2 = "=== MM Settings ===";
extern double  LotIncrement   = 100;
extern double  StartLotIncr   = 0.01;
extern double  MultIncrement  = 20;
extern double  StartMultIncr  = 0.1;

extern string  s3 = "=== Random Settings ===";
extern bool    CloseProfitFriday =  true;
extern string  FridayCloseTime   = "23:59";
extern bool    CloseProfitEOD    =  true;
extern string  EODCloseTime      = "17:00";

double         myPoint, divider;
string         msg;
double         ugrid, lgrid;
double         blot, slot;
int            Slippage          = 5;
int            NumRetries        = 10;
int            RetryDelayInSec   = 5; 
string         TradeComment      = "";
double         bl, sl, bs, ss;
double         currstartlot, startbalance, currmultiplier, startbalance2;
datetime       fridayh, fridaym, eodh, eodm ;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits==3 || Digits==5) {
      myPoint = 10 * Point;
      divider = 10;
   }  else {
      myPoint = Point;
      divider = 1;
   }
   
   fridayh = TimeHour(StrToTime(FridayCloseTime));
   fridaym = TimeMinute(StrToTime(FridayCloseTime));
   eodh = TimeHour(StrToTime(EODCloseTime));
   eodm = TimeMinute(StrToTime(EODCloseTime));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ResetGridLines();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   msg = "EA Active..."+NL;
   
   if(CountOrders() == 0) {
      if(MarketInfo(Symbol(), MODE_SPREAD)/divider <= MaxSpread) {
         ManageLotSizeAndMult();
         
         if(ugrid == 0)
            PlotGridLines(Bid);
            
         msg = msg + "New Squence. Waiting for first trigger.. "+NL;
         WaitForTrigger();
      }         
      else
         msg = msg + "New entries not allowed. Current spread ("+ (MarketInfo(Symbol(), MODE_SPREAD)/divider) + ") greater than MaxSpread"+NL;
   } else {
      if(CloseProfitFriday && DayOfWeek() == 5 && Hour() == fridayh && Minute() == fridaym) {
         if(GetCurrentPL() > 0) {
            Print("Friday Close .. Current PL:"+GetCurrentPL()+" Close all positions!");
            CloseAllPositions();
         }
      }
      
      if(CloseProfitEOD && Hour() == eodh && Minute() == eodm) {
         if(GetCurrentPL() > 0) {
            Print("EOD Close .. Current PL:"+GetCurrentPL()+" Close all positions!");
            CloseAllPositions();
         }
      }
   
      if(CountPending() < 2) {
         DeletePendingOrders();
         
         if(GetCurrentPL() > 0) {
            Print("Current PL:"+GetCurrentPL()+" Close all positions!");
            CloseAllPositions();
         }
                     
         int tick = LastOpenTicket();
         if(OrderSelect(tick, SELECT_BY_TICKET))
            PlaceGridTrades(OrderOpenPrice(),OrderType());
      }
      GetDispValues();
   }
   
   Comment(msg);
//----
   return(0);
  }
//+------------------------------------------------------------------+

void ManageLotSizeAndMult()
{
   if(startbalance == 0) {
      startbalance = AccountBalance();
      currstartlot = StartLot;
      Print("Initial Sequence. startbalance-lot = "+startbalance+" Start Lot:"+currstartlot);
   }
      
   if(AccountBalance() >= startbalance+LotIncrement) {
      Print("New Sequence. Account Balance increased by "+LotIncrement+" startbalance-lot = "+startbalance+" Current Balance = "+AccountBalance());
      startbalance = AccountBalance();
      currstartlot = currstartlot+StartLotIncr;
      Print("Resetting startbalance-lot to "+startbalance);
   }
   
   if(startbalance2 == 0) {
      startbalance2 = AccountBalance();
      currmultiplier = Multiplier;
      Print("Initial Sequence. startbalance-mult = "+startbalance2+" Multiplier:"+currmultiplier);
   }
      
   if(AccountBalance() >= startbalance2+MultIncrement) {
      Print("New Sequence. Account Balance increased by "+MultIncrement+" startbalance-mult = "+startbalance2+" Current Balance = "+AccountBalance());
      startbalance2 = AccountBalance();
      currmultiplier = currmultiplier+StartMultIncr;
      Print("Resetting startbalance-mult to "+startbalance2);
   }
}

void GetDispValues()
{
   msg = msg + NL+"Open Orders - Longs : "+CountOrdersByType(OP_BUY)+" Shorts : "+CountOrdersByType(OP_SELL)+NL;
   msg = msg + "Lot Size - Longs : "+DoubleToStr(CountLotsByType(OP_BUY),2)+" Shorts : "+DoubleToStr(CountLotsByType(OP_SELL),2)+NL;
   msg = msg + "Gross P/L : "+DoubleToStr(GetCurrentPL(),2)+" ( Longs: "+CalcProfitByType(OP_BUY)+" Shorts: "+CalcProfitByType(OP_SELL)+")"+NL;
}

int CountOrdersByType(int type)
{
   int count = 0 ;
   for (int y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType()==type) {
         count++;
      }
   }
   return(count);
}

double CountLotsByType(int type)
{
   double lots = 0 ;
   for (int y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType()==type) {
         lots = lots + OrderLots();
      }
   }
   return(lots);
}

string CalcProfitByType(int type)
{
   double prof = 0 ;
   for (int y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType()==type) {
         prof = prof + OrderProfit();
      }
   }
   return(DoubleToStr(prof,2));
}

int CountOrders()
{
   int count = 0;
      
   for (int y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
         count++;
   }
   
   return(count);
}

double GetCurrentPL()
{
   double pl = 0;
      
   for (int y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
         pl = pl + OrderProfit();
   }
   
   return(pl);
}

int CountPending()
{
   int count = 0;
      
   for (int y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() > OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
         count++;
   }
   
   return(count);
}

void DeletePendingOrders()
{
    bool success;
    for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType() > OP_SELL) {
         int i = 0;
         while(i < NumRetries) {
            i += 1;
            while(IsTradeContextBusy())Sleep(RetryDelayInSec*1000);
      	   RefreshRates();
            
            Print("Try "+i+" : Delete "+OrderTicket());
            success = OrderDelete(OrderTicket());
            if(!success){
               Print("Failed to delete pending order "+OrderTicket()+" Error code:"+GetLastError());
               if(i == NumRetries)
                  Print("*** Final retry to DELETE PENDING ORDER failed. Delete the trade manually ***");
            } else
               i = NumRetries;
         }
      }
    } 
}

void WaitForTrigger()
{
   if(Ask >= ugrid){
      ResetGridLines();
      Print("Confirm Buy trade..");
      PlaceOrder(OP_BUY, GetLots(OP_BUY));
   } else if(Bid <= lgrid) {
      ResetGridLines();
      Print("Confirm Sell trade..");
      PlaceOrder(OP_SELL, GetLots(OP_BUY));
   }
}

double PlaceOrder(int type, double lot, double entry = 0)
{
   Print("PlaceOrder called.. Type : "+TypeToStr(type));
   color  col = CLR_NONE;        
      
   int i = 0;
   while(i < NumRetries) {
      i += 1;
      while(IsTradeContextBusy())Sleep(RetryDelayInSec*1000);
	   RefreshRates();
	   if(type == OP_BUY) {
         entry = Ask;
         col   = Blue;
      }
      else if (type == OP_SELL) {
         entry = Bid;
         col   = Red;
      }

      Print("Try "+i+" : Open "+TypeToStr(type)+" order. Entry : "+DoubleToStr(entry,Digits));
      int ticket = OrderSend(Symbol(),type,lot,entry,Slippage,0,0,TradeComment,Magic,0,col);
      if(ticket <= 0){
         Print("ERROR opening order. ErrorCode:"+GetLastError());
         if(i == NumRetries) {
            Print("*** Final retry to OPEN ORDER failed ***");
            return(false);
         }
      } else {
         SetSLandTP(ticket);
         i = NumRetries;
         return(ticket);
      }
   }
   
   return(0);
}

string TypeToStr(int type)
{
   if(type == OP_BUY)
      return("BUY");
   else if(type == OP_BUY)
      return("SELL");
   else if(type == OP_BUYSTOP)
      return("BUY STOP");
   else if(type == OP_SELLSTOP)
      return("SELL STOP");
   else if(type == OP_BUYLIMIT)
      return("BUY LIMIT");
   else if(type == OP_SELLLIMIT)
      return("SELL LIMIT");
}

void SetSLandTP(int tick)
{
   OrderSelect(tick,SELECT_BY_TICKET);
   
   double sl = CalcSL(OrderType(),OrderOpenPrice());
   double tp = CalcTP(OrderType(),OrderOpenPrice(),sl);
   
   int i = 0;
   while(i < NumRetries) {
      i += 1;
      while(IsTradeContextBusy())Sleep(RetryDelayInSec*1000);
	   RefreshRates();
	   
	   Print("Try "+i+" : Modify Ticket#"+tick+" SL: "+DoubleToStr(sl,Digits)+" TP: "+DoubleToStr(tp,Digits));
      int t = OrderModify(tick, OrderOpenPrice(), NormalizeDouble(sl,Digits), NormalizeDouble(tp, Digits), 0);
      if(t <= 0) {
          Print("*** ERROR modifying market order. Unable to set SL/TP. ErrorCode:"+GetLastError());
          if(i == NumRetries) {
            Print("*** Final retry to SET SL/TP failed. Manually set the same or close the open order ***");
            return(0);
         }
      } else {
         i = NumRetries;
      }
   }
}

double CalcSL(int type, double entry)
{
   double stoploss = 0;
  
   if((type == OP_BUY || type == OP_BUYLIMIT || type == OP_BUYSTOP) && SL > 0)
      stoploss = entry - SL*myPoint;
   else if((type == OP_SELL || type == OP_SELLLIMIT || type == OP_SELLSTOP) && SL > 0)
      stoploss = entry + SL*myPoint;

   return(NormalizeDouble(stoploss,Digits));
}

double CalcTP(int type, double entry, double sl)
{
   double takeprofit = 0;

   if((type == OP_BUY || type == OP_BUYLIMIT || type == OP_BUYSTOP) && TP > 0)
      takeprofit = entry + TP*myPoint;
   else if((type == OP_SELL || type == OP_SELLLIMIT || type == OP_SELLSTOP) && TP > 0)
      takeprofit = entry - TP*myPoint;

   return(NormalizeDouble(takeprofit,Digits));
}

void PlotGridLines(double base)
{
   Print("PlotGridLines base = "+base);
   double grid    = GridSpace;
   double upper = NormalizeDouble(base/myPoint,0);
   int level = 0 ;
   while(level <= grid) {
      upper = upper + 1;
      if(MathMod(upper, grid) == 0)
         break;
      level++;
   }
   
   double bstart = upper*myPoint;
   double sstart = bstart - grid*myPoint;

   ugrid = NormalizeDouble(bstart,Digits) ;
   lgrid = NormalizeDouble(sstart,Digits) ;
   
   Print("ugrid = "+ugrid+" lgrid = "+lgrid);
   
   DrawTrendLine("Buy",ugrid,Time[0],ugrid,Time[0]+86400,DodgerBlue);
   DrawTrendLine("Sell",lgrid,Time[0],lgrid,Time[0]+86400,Magenta);
}

void PlaceGridTrades(double entry, int type)
{
   if(type == OP_BUY)
      entry = GetNearestRN(entry,-1);
   else
      entry = GetNearestRN(entry,1);
   
   for(int i = 1; i < 100 ; i++) {   
      double bentry = NormalizeDouble(entry + i * GridSpace * myPoint, Digits);
      if(CountTradesAtLevel(bentry) < TradesPerLevel)
         break;
   }
   for(i = 1; i < 100 ; i++) {     
      double sentry = NormalizeDouble(entry - i * GridSpace * myPoint, Digits);
      if(CountTradesAtLevel(sentry) < TradesPerLevel)
         break;
   }
   
   int blast = LastOpenTypeAtLevel(bentry);
   int slast = LastOpenTypeAtLevel(sentry);
   
   if(blast == -1 || blast == OP_SELL)
      PlaceOrder(OP_BUYSTOP, GetLots(OP_BUY), bentry);
   else
      PlaceOrder(OP_SELLLIMIT, GetLots(OP_SELL), bentry);
   
   if(slast == -1 || slast == OP_BUY)
      PlaceOrder(OP_SELLSTOP, GetLots(OP_SELL), sentry);
   else
      PlaceOrder(OP_BUYLIMIT, GetLots(OP_BUY), sentry);
}

int CountTradesAtLevel(double price) 
{
   int count = 0;
   
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType() <= OP_SELL && OrderOpenPrice() <= price+5*myPoint && OrderOpenPrice() >= price-5*myPoint )
         count++;         
   }
   
   return(count);
}

double GetNearestRN(double p, int incr)
{
   double price = NormalizeDouble(p/myPoint,0);
   
   int level = 0 ;
   while(level <= GridSpace) {
      if(MathMod(price, GridSpace) == 0)
         break;
      price = price + incr;
      level++;
   }
   
   return(price*myPoint);
}

void DrawTrendLine(string name, double y1, datetime x1, double y2, datetime x2, color lineColor)
{
   ObjectDelete(name);
   ObjectCreate(name, OBJ_TREND, 0, x1, y1, x2, y2);
   ObjectSetText(name, DoubleToStr(y1,Digits));   
   ObjectSet(name, OBJPROP_RAY, 1);
   ObjectSet(name, OBJPROP_COLOR, lineColor);
   ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
}

void ResetGridLines()
{
   ObjectsDeleteAll();
   ugrid = 0;
   lgrid = 0;

}

int LastOpenTypeAtLevel(double price)
{
   datetime t;
   int type = -1;
      
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType() <= OP_SELL && OrderOpenPrice() <= price+5*myPoint && OrderOpenPrice() >= price-5*myPoint ) {
         if(OrderOpenTime() > t) {
            t = OrderOpenTime();
            type = OrderType();
         }
      }
   }
   
   return(type);
}

double LastOpenTicket() 
{
   datetime t;
   int tick;
      
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType() <= OP_SELL) {
         if(OrderOpenTime() > t) {
            t = OrderOpenTime();
            tick = OrderTicket();
         }
      }
   }
   
   return(tick);
}

double GetLots(int type)
{
   datetime t;
   double lot = 0;
            
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol() && OrderType() == type ) {
         if(OrderOpenTime() > t) {
            t = OrderOpenTime();
            lot = OrderLots();
         }
      }
   }
   Print("last lot = "+lot);
   if(lot == 0) {
      Print("Returning "+currstartlot);
      return(currstartlot);
   }
   
   Print("Returning "+NormalizeDouble(lot*currmultiplier, 2));
   return(NormalizeDouble(lot*currmultiplier, 2));
}

bool CloseAllPositions()
{
    bool success;
    bool allsuccess = true;
    
    for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) {
         int i = 0;
         while(i < NumRetries) {
            i += 1;
            while(IsTradeContextBusy())Sleep(RetryDelayInSec*1000);
      	   RefreshRates();
            
            Print("Try "+i+" : Close "+OrderTicket());
            if(OrderType() == OP_BUY || OrderType() == OP_SELL)
               success = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 99, 0);
            else
               success = OrderDelete(OrderTicket());
               
            if(!success){
               Print("Failed to close order "+OrderTicket()+" Error code:"+GetLastError());
               if(i == NumRetries) {
                  allsuccess = false;
                  Print("*** Final retry to CLOSE ORDER failed. Close trade manually ***");
               }
            } else {
               i = NumRetries;
            }
         }
      }
    }
    
    return(allsuccess); 
}